{ VERSION: 1.3 }
{ 1.3 / 4.6.2006
  - oteven souboru z pkazovho dku generuje strnky jenom pro tento soubor
    ( viz. SingletonMode )
  - registruje shell operaci "Nov"->"kolnk"  
  1.2 / 3.6.2006
  - azen aktulnch kol dv na prvn msto ty co nejsou ekajc ( viz.
    TodoListSortKey() )
  - nov koncov stav 'featureDuplicate'
  - opraveno: nefungoval vbr textu my ( Browser.UserInterfaceOptions obsahovalo
    DIALOG )
}

unit main;

interface

uses
  Windows, Messages, fileSys, RARFileSys, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, OleCtrls, SHDocVw, XPMan, DB,
  ExtCtrls, IniFilesD5, cfgArray, EmbeddedWB, uTodoList, uTodoLists, MiscUtils, uWebUI,
  uWebServer, HttpSrv;

type
  TOpenFileFlags = set of (
    ofNavigate,              // jestli se ma zmenit aktualni stranka
    ofCreateNew,             // jestli se ma zalozit novy
    ofUsePassword,           // jestli se musi pouzit heslo
    ofRaiseException         // jestli ma pri problemech vyhodit exception nebo jenom
                             // vratit chybovy priznak
  );
  TOpenFileResult = (
    orOK,
    orBadPassword,
    orError
  );
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuOpen: TMenuItem;
    OpenDialog: TOpenDialog;
    StatusBar: TStatusBar;
    MenuShow: TMenuItem;
    MenuShowStatusBar: TMenuItem;
    MenuClose: TMenuItem;
    MenuWebBrowse: TMenuItem;
    N3: TMenuItem;
    XPManifest: TXPManifest;
    N1: TMenuItem;
    MenuFilePrint: TMenuItem;
    Browser: TEmbeddedWB;
    MenuFileNew: TMenuItem;
    SaveDialog: TSaveDialog;
    MenuImportExportSeparator: TMenuItem;
    MenuFileExport: TMenuItem;
    ExportDialog: TSaveDialog;
    MenuFileExportAll: TMenuItem;
    MenuFileImport: TMenuItem;
    ImportDialog: TOpenDialog;
    MenuFullScreen: TMenuItem;
    N4: TMenuItem;
    MenuFontSize: TMenuItem;
    Mal1: TMenuItem;
    Stedn1: TMenuItem;
    Velk1: TMenuItem;
    AutoSaveTimer: TTimer;
    MenuHelp: TMenuItem;
    MenuAbout: TMenuItem;
    MenuReOpen: TMenuItem;
    N5: TMenuItem;
    MenuFileCrypt: TMenuItem;
    procedure MenuQuitClick(Sender: TObject);
    procedure MenuOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BrowserStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure MenuShowStatusBarClick(Sender: TObject);
    procedure BrowserDownloadBegin(Sender: TObject);
    procedure BrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure MenuCloseClick(Sender: TObject);
    procedure MenuFileClick(Sender: TObject);
    procedure BrowserTitleChange(Sender: TObject; const Text: WideString);
    procedure MenuWebBrowseClick(Sender: TObject);
    procedure MenuFilePrintClick(Sender: TObject);
    procedure MenuFileNewClick(Sender: TObject);
    procedure MenuFileExportAllClick(Sender: TObject);
    procedure MenuFileImportClick(Sender: TObject);
    procedure MenuFullScreenClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    function BrowserTranslateAccelerator(const lpMsg: PMsg;
      const pguidCmdGroup: PGUID; const nCmdID: Cardinal): HRESULT;
    procedure FontSizeChanged(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AutoSaveTimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuFileCryptClick(Sender: TObject);
  private
    Server: TWebServer;
    procedure ServerServerStarted(Sender: TObject);
  private
    ConfigFiles: TCfgArrayReader;
    Cfg: TIniFile;
    MRU: TTodoBook;
    procedure BuildMRUMenu(CheckFiles: Boolean = False);
    procedure MRUClick(Sender: TObject);
  private
    StatusPrefix: string;
    StatusHost: string;
    StatusServer: string;
  private
    Pager: TPageGenerator;
  private
    Todos: TDataSet;
    TodoNotes: TDataSet;

    TodoList: TDataNavigator;
    CompleteList: TDataNavigator;
    HistoryList: TDataNavigator;

    procedure RecordChanged(Sender: TDataSet);
    procedure DeleteRecord(Sender: TDataSet);
    procedure NewRecord(Sender: TDataSet; Updating: Boolean = False);
  private
    function HistoryListSortKey(Sender: TObject; Data: TDataSet): string;
    function CompleteListSortKey(Sender: TObject; Data: TDataSet): string;
    function TodoListSortKey(Sender: TObject; Data: TDataSet): string;
  private
    function DefaultPage: string;
  private
    CategoryEnum,
    StatusEnum,
    ActivityEnum,
    PriorityEnum: TEnum;
    CategoryDescriptions,
    StatusDescriptions,
    ActivityDescriptions,
    PriorityDescriptions: string;
    NullCategory,
    NullStatus,
    NullActivity,
    NullPriority: string;
  private
    RemoteAudience: Boolean;
    Todo: TTodoList;
    ForcedReadOnly: Boolean;
    FCurrentProject: string;
    CurrentFile: string;
    function ProjectName(const FileName: string): string;
    function ValidProjectName(const Value: string): Boolean;
    function ProjectFile(const Value: string): string;
    procedure _SetCurrentProject(const Value: string);
    procedure SetCurrentProject(const Value: string; const User: string; const Password: string);
    procedure SetClient(const Host: string; const User: string; const Password: string);
    procedure SetPageStyle(Sender: TObject);
  public
    procedure CloseFile(Navigate: Boolean = True);
    function OpenFile(const AFileName: string; Flags: TOpenFileFlags = [ofNavigate, ofRaiseException]; const Password: string = ''): TOpenFileResult;
    property CurrentProject: string read FCurrentProject write _SetCurrentProject;
  private
    procedure HideSplash(Sender: TObject);
  private
    procedure ScheduleAutoSave(Sender: TObject);
  private
    WindowStateEnum: TEnum;
  private
    FFullScreen: Boolean;
    FNormalStyle: TWindowStyle;
    FNormalStatusBar: Boolean;
    FNormalWindowState: TWindowState;
    FNormalRect: TRect;
    procedure SetFullScreen(Value: Boolean);
  public
    property FullScreen: Boolean read FFullScreen write SetFullScreen;
  private
    FFontSize: Integer;
    function GetFontSize: Integer;
    procedure SetFontSize(Value: Integer);
  public
    property FontSize: Integer read GetFontSize write SetFontSize;
  private
    SingletonMode: Boolean;
    procedure SetSingletonMode;
  end;

var
  MainForm: TMainForm;

implementation
uses
  Registry, DateUtils, fileUtils, GraphUtil, HTTPApp, ShellApi, wSplash, PackFileSys, SynaCode;

{$R *.dfm}

const
  // TUNE:
  WebRootFolder = 'todolist';

function WebRootPath: string;
begin
  if WebRootFolder = '' then
    Result := ''
  else
    Result := WebRootFolder + '/'
end;

procedure TMainForm.CloseFile(Navigate: Boolean);
begin
  if Assigned(Todos) and Todos.Active and (CurrentFile <> '') then begin
    // TODO: except
    Todos := nil;
    TodoNotes := nil;

    FreeAndNil(TodoList);
    FreeAndNil(HistoryList);
    FreeAndNil(CompleteList);

    FreeAndNil(Todo);
  end;
  CurrentFile := '';
  FCurrentProject := '';
  Caption := '';
  Application.Title := Caption;

  if Navigate then
    // TODO: Browser.Navigate('about:blank');
    Browser.Navigate(Format('http://127.0.0.1:%d/%s%s', [Server.Port, WebRootPath, DefaultPage]));
end;

{
var
  I: Integer;
begin
  Result := '';
  for I := 1 to Length(Name) do
    if (Ord(Name[I]) <= 32) or (Ord(Name[I]) > 127) or (Name[I] = '$') then
      Result := Result + '$' + IntToHex(Ord(Name[I]), 2)
    else
      Result := Result + Name[I]
end;
}

{
var
  I: Integer;
begin
  Result := '';
  I := 1;
  while I <= Length(Name) do
    if Name[I] = '$' then begin
      Result := Result + Chr(StrToInt(Copy(Name, I, 3)));
      Inc(I, 3)
    end else begin
      Result := Result + Name[I];
      Inc(I)
    end
end;
}

function TMainForm.ProjectName(const FileName: string): string;
begin
  Result := ChangeFileExt(ExtractFileName(FileName), '');
end;

function TMainForm.ValidProjectName(const Value: string): Boolean;
begin
  Result := (Value = '') or (ProjectFile(Value) <> '')
end;

function TMainForm.ProjectFile(const Value: string): string;
var
  Item: TTodoBookEntry;
begin
  Result := '';
  if Value = '' then exit;
  if SameText(Value, CurrentProject) then begin
    Result := CurrentFile;
    exit
  end;
  Item := MRU.FindProject(Value);
  if Assigned(Item) then
    Result := Item.FileName
end;

function FileImage(const FileName: string): string; overload;
begin
  if (Copy(FileName, 1, 2) = '\\') or (GetDriveType(PChar(ExtractFileDrive(FileName))) = DRIVE_REMOTE) then
    Result := 'shared'
  else
    Result := 'personal'
end;

function FileImage(IsShared: Boolean): string; overload;
begin
  if IsShared then
    Result := 'shared'
  else
    Result := 'personal'
end;

procedure TMainForm._SetCurrentProject(const Value: string);
begin
  SetCurrentProject(Value, '', '')
end;

procedure TMainForm.SetClient(const Host: string; const User: string; const Password: string);
begin
  RemoteAudience := (Host <> '') and ((Host <> StatusHost) and (Host <> StatusServer) { TODO: })
end;

procedure TMainForm.SetPageStyle(Sender: TObject);
begin
  if SingletonMode then
    Pager.Style := Pager.Style - [psProjectList]
end;

procedure TMainForm.SetCurrentProject(const Value: string; const User: string; const Password: string);
var
  Item: TTodoBookEntry;
label
  again;
begin
  if not SameText(FCurrentProject, Value) then begin
  again:
    CloseFile(False);
    Item := MRU.FindProject(Value);
    if Assigned(Item) then
      OpenFile(Item.FileName, [ofRaiseException], Password)
  end else
  if RemoteAudience then begin
    if (FileImage(CurrentFile) <> 'shared') and (not Todo.ReadOnly) then begin
      goto again
    end
  end else begin
    if Todo.ReadOnly and ForcedReadOnly then
      goto again;
  end;
  try
    if Assigned(Todo) then
      Pager.UserName := Todo.ValidateUser(User, Password)
  except
    CloseFile(False);
    raise
  end
end;

type
  TLogonTodoList = class(TTodoList)
  protected
    function UI: TMainForm;
    procedure UpdateData(Sender: TDataSet; State: TDataState); override;
  end;

function TLogonTodoList.UI: TMainForm;
begin
  Result := MainForm
end;

procedure TLogonTodoList.UpdateData(Sender: TDataSet; State: TDataState);
begin
  if (State = dInsert) and (Sender.Tag in [di_Todos, di_TodoNotes]) then begin
    if UI.Pager.UserName <> '' then
      Sender.FieldValues['ReporterID'] := UI.Pager.UserName
  end
end;

function TMainForm.OpenFile(const AFileName: string; Flags: TOpenFileFlags; const Password: string): TOpenFileResult;
var
  I: Integer;
  Navigate: Boolean;
  CreateNew: Boolean;
  Ok: Boolean;
begin
  try
    Navigate := ofNavigate in Flags;
    CreateNew := ofCreateNew in Flags;

    Result := orError;

    CloseFile(Navigate);

    Todo := TLogonTodoList.Create(nil);
    try
      Todo.OnChange := ScheduleAutoSave;
      ForcedReadOnly := RemoteAudience and (FileImage(AFileName) <> 'shared');
      if ofUsePassword in Flags then begin
        Todo.Password := Password;
        Ok := Todo.Connect(AFileName, CreateNew, ForcedReadOnly);
      end else
      try
        Ok := Todo.Connect(AFileName, CreateNew, ForcedReadOnly);
      except
        if Password <> '' then begin
          Todo.Password := Password;
          Ok := Todo.Connect(AFileName, CreateNew, ForcedReadOnly)
        end else
          raise
      end;
      if not Ok then begin
        FreeAndNil(Todo);
        exit
      end;

      CurrentFile := Todo.FileName;
      FCurrentProject := ProjectName(CurrentFile);
      Caption := Todo.FileName;
      Application.Title := Caption;

      Todos := Todo.Todos;

      TodoList := TDataNavigator.Create(Self);
      TodoList.DataSet := Todos;
      TodoList.KeyField := 'ID';
      TodoList.OnGetSortKey := TodoListSortKey;

      HistoryList := TDataNavigator.Create(Self);
      HistoryList.DataSet := Todos;
      HistoryList.KeyField := 'ID';
      HistoryList.Ascending := False;
      HistoryList.OnGetSortKey := HistoryListSortKey;

      CompleteList := TDataNavigator.Create(Self);
      CompleteList.DataSet := Todos;
      CompleteList.KeyField := 'ID';
      CompleteList.Ascending := True;
      CompleteList.OnGetSortKey := CompleteListSortKey;

      TodoNotes := Todo.TodoNotes;

      Todo.OnNewRecord := NewRecord;
      Todo.OnRecordChanged := RecordChanged;
      Todo.OnDeleteRecord := DeleteRecord;

      Todo.ActivityEnum := ActivityEnum;
      Todo.StatusEnum := StatusEnum;
      Todo.CategoryEnum := CategoryEnum;
      Todo.PriorityEnum := PriorityEnum;

      Todo.LoadData;

      TodoList.Sort;
      HistoryList.Sort;
      CompleteList.Sort;

      I := MRU.IndexOf(CurrentFile);
      if I >= 0 then
        MRU.Move(I, 0)
      else
        MRU.Insert(0, CurrentFile);

      BuildMRUMenu(CreateNew);

      if Navigate then
        Browser.Navigate(Format('http://127.0.0.1:%d/%s%s/todo/%s', [Server.Port, WebRootPath, WebName(CurrentProject), DefaultPage]));

      Result := orOK
    except
      Todos := nil;
      TodoNotes := nil;
      FreeAndNil(Todo);
      raise
    end;
  except
    on EBadPassword do begin
      Result := orBadPassword;
      if ofRaiseException in Flags then
        raise
    end;
    on Exception do begin
      Result := orError;
      if ofRaiseException in Flags then
        raise
    end;
  end
end;

procedure TMainForm.MenuQuitClick(Sender: TObject);
begin
  Close
end;

procedure TMainForm.MRUClick(Sender: TObject);
var
  M: TMenuItem absolute Sender;
begin
  OpenFile(MRU[M.Tag].FileName)
end;

procedure TMainForm.BuildMRUMenu(CheckFiles: Boolean);
var
  M: TMenuItem;
  I: Integer;
  List: TList;
  No: Integer;

  function NextItem(M: TMenuItem): TMenuItem;
  begin
    Result := M.Parent.Items[M.Parent.IndexOf(M) + 1]
  end;

begin
  List := TList.Create;
  try
    for I := 0 to MenuReOpen.Count - 1 do
      List.Add(MenuReOpen.Items[I]);

    for I := 0 to List.Count - 1 do
      TObject(List[I]).Free;

    List.Clear;
    No := 0;
    for I := 0 to MRU.Count - 1 do begin
      M := TMenuItem.Create(Self);

      if CheckFiles then
        MRU[I].Enabled := True;

      if MRU[I].Enabled then begin
        Inc(No);
        if No < 10 then
          M.Caption := Format('%d. %s', [No, MRU[I].ProjectName])
        else
          M.Caption := MRU[I].ProjectName;
        M.OnClick := MRUClick
      end else begin
        { TODO: kdyz to tam necham, tak bude seznam moc dlouhy
        M.Caption := ProjectName(MRU[I]);
        M.Enabled := False;
        }
        M.Free;
        continue
      end;
      M.Hint := MRU[I].FileName;
      M.Tag := I;
      MenuReOpen.Add(M);
    end;

    MenuReOpen.Enabled := MenuReOpen.Count <> 0
  finally
    List.Free
  end
end;

procedure TMainForm.FormDestroy(Sender: TObject);
const
  Prefix = 'http://';
var
  URL: string;
  I: Integer;
begin
  AutoSaveTimer.Enabled := False;

  // Cfg.WriteString('Options', 'LastFile', CurrentFile);
  URL := Browser.LocationURL;
  if SameText(Copy(URL, 1, Length(Prefix)), Prefix) then begin
    Delete(URL, 1, Length(Prefix));
    I := Pos('/', URL);
    if I = 0 then
      URL := '/'
    else
      Delete(URL, 1, I - 1)
  end;

  Cfg.WriteBool('Options', 'FullScreen', FullScreen);
  FullScreen := False;

  // TODO: nejak se neudrzi stav wsMinimized
  Cfg.WriteEnum('Options', 'WindowState', Ord(WindowState), WindowStateEnum);

  Cfg.WriteInteger('Options', 'FontSize', FontSize);
  Cfg.WriteBool('Options', 'StatusBar', MenuShowStatusBar.Checked);

  if not SingletonMode then begin
    Cfg.WriteString('Options', 'LastURL', URL);
    Cfg.WriteString('Files', 'MRU', StringReplace(TrimRight(MRU.Text), #13#10, ';', [rfReplaceAll]));
  end;

  CloseFile(False);
  MRU.Free;
  Cfg.Free;

  WindowStateEnum.Free;

  CategoryEnum.Free;
  StatusEnum.Free;
  ActivityEnum.Free;
  PriorityEnum.Free;

  ConfigFiles.Free
end;

type
  TGenerator = class(TPageGenerator)
  private
    function UI: TMainForm;
  protected
    function SelectProject(const Value: string; const User: string; const Password: string): string; override;
    procedure GetUserNames(List: TStrings; var Indexed: Boolean); override;
  protected
    function RootDefaultPage: string; override;
    function CurrentFile: string; override;
    function DefaultPage: string; override;
    function FontSize: Integer; override;
    function ConfigFiles: TCfgArrayReader; override;
    function MRU: TTodoBook; override;
  end;

function TGenerator.UI: TMainForm;
begin
  Result := Owner as TMainForm
end;

function TGenerator.SelectProject(const Value: string; const User: string; const Password: string): string;
begin
  UI.SetCurrentProject(Value, User, Password);
  Result := UI.CurrentProject;
  Self.Todos := UI.Todos;
  Self.TodoNotes := UI.TodoNotes;
  Self.Todo := UI.Todo;
  Self.CategoryEnum := UI.CategoryEnum;
  Self.StatusEnum := UI.StatusEnum;
  Self.ActivityEnum := UI.ActivityEnum;
  Self.PriorityEnum := UI.PriorityEnum;
  Self.CategoryDescriptions := UI.CategoryDescriptions;
  Self.StatusDescriptions := UI.StatusDescriptions;
  Self.ActivityDescriptions := UI.ActivityDescriptions;
  Self.PriorityDescriptions := UI.PriorityDescriptions;
  Self.NullCategory := UI.NullCategory;
  Self.NullStatus := UI.NullStatus;
  Self.NullActivity := UI.NullActivity;
  Self.NullPriority := UI.NullPriority;
  Self.TodoList := UI.TodoList;
  Self.CompleteList := UI.CompleteList;
  Self.HistoryList := UI.HistoryList;
end;

procedure TGenerator.GetUserNames(List: TStrings; var Indexed: Boolean);
var
  I: Integer;
begin
  List.Text := StringReplace(Todo.GetParam('Users', ''), ',', #13#10, [rfReplaceAll]);
  for I := 0 to List.Count - 1 do
    List[I] := List.Names[I];
  Indexed := False
end;

function TGenerator.RootDefaultPage: string;
begin
  Result := Format('/%s%s', [WebRootPath, DefaultPage])
end;

function TGenerator.CurrentFile: string;
begin
  Result := UI.CurrentFile
end;

function TGenerator.DefaultPage: string;
begin
  Result := UI.DefaultPage
end;

function TGenerator.FontSize: Integer;
begin
  Result := UI.FontSize
end;

function TGenerator.ConfigFiles: TCfgArrayReader;
begin
  Result := UI.ConfigFiles
end;

function TGenerator.MRU: TTodoBook;
begin
  Result := UI.MRU
end;

procedure TMainForm.FormCreate(Sender: TObject);

  procedure ShellRegister;
  var
    Server: string;
  begin
    Server := ParamStr(0);
    RegWrite('HKCR\.todolist\','todolistFile');
    RegWrite('HKCR\.todolist\ShellNew\NullFile', '');
    RegWrite('HKCR\todolistFile\', 'kolnk');
    RegWrite('HKCR\todolistFile\DefaultIcon\', Server);
    RegWrite('HKCR\todolistFile\shell\open\command\','"'+Server+'" "%1"')
  end;

begin
  OnCreate := nil;

  ShellRegister;

  Pager := TGenerator.Create(Self);

  Application.OnActivate := OnActivate;

  Caption := '';
  Application.Title := Caption;
  Cfg := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));

  Pager.HomeLinkFormat := StringReplace(Cfg.ReadString('Options', 'HomeLink', ''), '%1', '%s', [rfReplaceAll]);

  MRU := TTodoBook.Create;

  MRU.Text := StringReplace(Cfg.ReadString('Files', 'MRU', ''), ';', #13#10, [rfReplaceAll]);
  BuildMRUMenu;

  MenuShowStatusBar.Checked := Cfg.ReadBool('Options', 'StatusBar', MenuShowStatusBar.Checked);
  StatusBar.Visible := MenuShowStatusBar.Checked;

  FontSize := Cfg.ReadInteger('Options', 'FontSize', FontSize);

  CloseFile(False);

  WindowStateEnum := TEnum.Create(Format('Normal=%d,Minimized=%d,Maximized=%d', [Ord(wsNormal), Ord(wsMinimized), Ord(wsMaximized)]));

  WindowState := TWindowState(Cfg.ReadEnum('Options', 'WindowState', Ord(wsMaximized), WindowStateEnum));

  MenuFullScreen.Checked := Cfg.ReadBool('Options', 'FullScreen', FullScreen);

  CategoryEnum := TEnum.Create('bug=1,task,feature,question');
  CategoryDescriptions := 'bug=chyba,task=kol,feature=nmt,question=otzka';
  NullCategory := 'bug';

  StatusEnum := TEnum.Create('active=1,'+
    'bugFixed,bugNoReproduce,bugDuplicate,bugPostponed,bugWontFix,bugNotBug,'+
    'taskFixed,taskDuplicate,taskWontFix,taskAlreadyImplemented,'+
    'featureImplemented,featureWontImplement,featureAlreadyImplemented,featureDuplicate,'+
    'questionResponded,questionWontRespond,questionSPAM,questionWaitingForInfo');
  StatusDescriptions := 'active=aktivn,'+
    'bugFixed=opraveno,bugNoReproduce=neopakovateln,bugDuplicate=duplicitn,bugPostponed=odloeno,bugWontFix=nebude se opravovat,bugNotBug=vlastnost nen chyba,'+
    'taskFixed=splnno,taskDuplicate=duplicitn,taskWontFix=nebude se dlat,taskAlreadyImplemented=u je to hotov,'+
    'featureImplemented=implementovno,featureWontImplement=nebude se implementovat,featureAlreadyImplemented=u implementovno,featureDuplicate=duplicitn poadavek,'+
    'questionResponded=zodpovzena,questionWontRespond=nebude se reagovat,questionSPAM=um,questionWaitingForInfo=je teba vce informac';
  NullStatus := 'active';

  ActivityEnum := TEnum.Create('notStarted=1,scheduledDevelopment,developing,scheduledTesting,testing,complete,closed,deleted');
  ActivityDescriptions := 'notStarted=ek,scheduledDevelopment=plnovan vroba,developing=ve vrob,scheduledTesting=plnovan testovn,testing=v testovn,complete=hotovo,closed=uzaveno,deleted=smazno';
  NullActivity := 'notStarted';

  PriorityEnum := TEnum.Create('highFix=1,mediumFix,lowFix,highWhenIdle,mediumWhenIdle,lowWhenIdle,dontFix');
  PriorityDescriptions := 'highFix=mus se vyeit !!,mediumFix=mus se vyeit !,lowFix=mus se vyeit,highWhenIdle=a bude as !!,mediumWhenIdle=a bude as !,lowWhenIdle=a bude as,dontFix=neeit';
  NullPriority := 'highWhenIdle';

  // TODO:

  ConfigFiles := TCfgReader.Create;

  Server := TWebServer.Create(Self);
  Server.DocDir := ConfigFiles.RootPath;
  Server.DefaultPage := 'index.htm';
  Server.WebRootFolder := WebRootFolder;
  Server.AutoPort := True;
  Server.OnStart := ServerServerStarted;
  Server.ValidProjectName := ValidProjectName;
  Server.OnSetClient := SetClient;
  Server.OnSetStyle := SetPageStyle;
  Server.Pager := Pager;
  Server.Start;

  // TODO: tohle vypne .dpr
  // OpenDialog.Filter := SaveDialog.Filter;

  NotifyWhenIdle(Self, MenuFullScreenClick)
end;

procedure TMainForm.BrowserStatusTextChange(Sender: TObject;
  const Text: WideString);
var
  S: string;
begin
  S := Text;
  if SameText(Copy(S, 1, Length(StatusPrefix)), StatusPrefix) then
    Delete(S, 1, Length(StatusPrefix));
  StatusBar.SimpleText := S
end;

procedure TMainForm.SetSingletonMode;
begin
  SingletonMode := True;
  MRU.Clear;
  if CurrentFile <> '' then
    MRU.Add(CurrentFile);
  Pager.HomeLinkFormat := ''
end;

procedure TMainForm.ServerServerStarted(Sender: TObject);
var
  FileName: string;
  URL: string;
begin
  StatusHost := Format('127.0.0.1:%d', [Server.Port]);
  StatusServer := '127.0.0.1';
  StatusPrefix := Format('http://%s', [StatusHost]);

  FileName := ParamStr(1);
  if FileName <> '' then begin
    if ExtractFileExt(FileName) = '' then begin
      CurrentProject := FileName;
      OpenFile(CurrentFile)
    end else
      OpenFile(ExpandFileName(FileName));
    // TODO: what if file doesn't exist ?
    SetSingletonMode;
  end else begin
    URL := Cfg.ReadString('Options', 'LastURL', '');

    if URL = '' then
      URL := '/' + WebRootPath + DefaultPage;

    if URL[1] = '/' then
      URL := StatusPrefix + URL;

    Browser.Navigate(URL)
  end
end;

procedure TMainForm.MenuShowStatusBarClick(Sender: TObject);
begin
  StatusBar.Visible := MenuShowStatusBar.Checked
end;

procedure TMainForm.BrowserDownloadBegin(Sender: TObject);
begin
  Screen.Cursor := crAppStart
end;

procedure TMainForm.BrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  Screen.Cursor := crDefault
end;

procedure TMainForm.MenuCloseClick(Sender: TObject);
begin
  CloseFile
end;

procedure TMainForm.MenuFileClick(Sender: TObject);
begin
  // TODO: pomuze pri neplatnem URL
  MenuClose.Enabled := CurrentFile <> '';
  MenuFileCrypt.Enabled := CurrentFile <> '';

  if SingletonMode then begin
    MenuFileNew.Enabled := False;
    MenuOpen.Enabled := False;
    MenuReOpen.Enabled := False;
    MenuClose.Enabled := False;
    MenuFileCrypt.Enabled := False;

    // MenuImportExportSeparator.Visible := False;
    MenuFileImport.Enabled := False;
    MenuFileExport.Enabled := False;
  end;
end;

procedure TMainForm.BrowserTitleChange(Sender: TObject;
  const Text: WideString);
begin
  // TODO:
  // Caption := Application.Title + ' - ' + Text
end;

procedure TMainForm.MenuWebBrowseClick(Sender: TObject);
var
  URL: string;
begin
  URL := Browser.LocationURL;
  ShellExecute(Handle, 'open', PChar(URL), nil, nil, sw_shownormal)
end;

function TMainForm.DefaultPage: string;
begin
  Result := LowerCase(Server.DefaultPage)
end;

//---------------------------------

procedure TMainForm.RecordChanged(Sender: TDataSet);

  procedure Migrate(const Sources: array of TDataNavigator; Destination: TDataNavigator);
  var
    I: Integer;
    Removed: Boolean;
  begin
    Removed := False;
    for I := Low(Sources) to High(Sources) do
      if Sources[I].Remove then begin
        Removed := True;
        break
      end;
    if Removed then begin
      Destination.Add;
      Destination.Sort
    end else
      Destination.Changed
  end;

begin
  if Sender = Todos then
  case Todo.TodoRecordActivity of
  aActive:
    Migrate([HistoryList, CompleteList], TodoList);
  aComplete:
    Migrate([HistoryList, TodoList], CompleteList);
  aClosed:
    Migrate([TodoList, CompleteList], HistoryList);
  else
    ; // TODO: to je pred deletem
  end
end;

procedure TMainForm.DeleteRecord(Sender: TDataSet);
begin
  if Sender = Todos then begin
    TodoList.Remove;
    HistoryList.Remove;
    CompleteList.Remove;
  end
end;

procedure TMainForm.NewRecord(Sender: TDataSet; Updating: Boolean);

  procedure Add(Destination: TDataNavigator);
  begin
    Destination.Add;
    if not Updating then
      Destination.Sort
  end;

begin
  if Sender = Todos then
  case Todo.TodoRecordActivity of
  aActive:
    Add(TodoList);
  aComplete:
    Add(CompleteList);
  aClosed:
    Add(HistoryList);
  else
    Assert(False)
  end
end;
//---------------------------------

function TMainForm.HistoryListSortKey(Sender: TObject; Data: TDataSet): string;
begin
  Result := FormatDateTime('yyyymmddhhnnss', Data.FieldByName('Closed').AsDateTime)
end;

function TMainForm.CompleteListSortKey(Sender: TObject; Data: TDataSet): string;
begin
  Result := FormatDateTime('yyyymmddhhnnss', Data.FieldByName('Resolved').AsDateTime)
end;

function TMainForm.TodoListSortKey(Sender: TObject; Data: TDataSet): string;
var
  F: TField;
  Value: string;
  Prio: Integer;
  Activ: Integer;
  Catg: Integer;

  function Enum(const Value: string; const Values: array of string; Base: Integer; DefaultValue: Integer): Integer;
  var
    I: Integer;
  begin
    for I := Low(Values) to High(Values) do
      if SameText(Value, Values[I]) then begin
        Result := (I - Low(Values)) + Base;
        exit
      end;
    Result := DefaultValue
  end;

begin
  F := Data.FieldByName('Priority');
  if F.IsNull then
    Value := NullPriority
  else
    Value := PriorityEnum.IDToName(F.AsInteger, NullPriority);

  Prio := Enum(Value, ['highFix', 'mediumFix', 'lowFix', 'highWhenIdle', 'mediumWhenIdle', 'lowWhenIdle', 'dontFix'], 1, 1 { TODO: ?});

  F := Data.FieldByName('Category');
  if F.IsNull then
    Value := NullCategory
  else
    Value := CategoryEnum.IDToName(F.AsInteger, NullCategory);

  // TUNE: order defines category priorities
  Catg := Enum(Value, ['bug' ,'question', 'task', 'feature'], 1, 1 { TODO: });

  F := Data.FieldByName('Activity');
  if F.IsNull then
    Value := NullActivity
  else
    Value := ActivityEnum.IDToName(F.AsInteger, NullActivity);

  Activ := Enum(Value, ['testing', 'developing', 'scheduledTesting', 'scheduledDevelopment', 'notStarted'], 1, 1 { TODO: });

  Result := IntToStr(Activ * 100 + Prio * 10 + Catg);
  Result := StringOfChar('0', 5 - Length(Result)) + Result;

  Result := Result + FormatDateTime('yyyymmddhhnnss', Data.FieldByName('Created').AsDateTime)
end;

procedure TMainForm.MenuFilePrintClick(Sender: TObject);
var
  Url: TIniFile;
  FileName: string;
begin
  // TODO:  Browser.PrintWithOptions
  FileName := GetTempFileName('.url');
  Url := TIniFile.Create(FileName);
  try
    Url.WriteString('InternetShortcut', 'URL', Browser.LocationURL);
  finally
    Url.Free
  end;
  ShellExecute(Handle, 'print', PChar(FileName), nil, nil, sw_shownormal)
end;

procedure TMainForm.MenuFileNewClick(Sender: TObject);
var
  FileName: string;
begin
  if SaveDialog.Execute then begin
    FileName := SaveDialog.FileName;
    try
      TFileStream.Create(FileName, fmCreate).Free;
      OpenFile(FileName, [ofNavigate, ofCreateNew, ofRaiseException])
    except
      DeleteFile(FileName);
      raise
    end
  end
end;

procedure Check(Condition: Boolean);
begin
  if not Condition then begin
    RaiseLastWin32Error;
    raise EInOutError.Create('');
  end
end;

procedure FixFileName(Dialog: TOpenDialog);
var
  Dir: string;
begin
  Dir := ExtractFileDir(Dialog.FileName);
  if (Dir <> '') and (not DirectoryExists(Dir)) then
    Dialog.FileName := ExtractFileName(Dialog.FileName)
end;

procedure TMainForm.MenuFileExportAllClick(Sender: TObject);
var
  URL: string;
  OldCurrentProject: string;
  Archive: TRARFileSystem;
  I: Integer;
begin
  ExportDialog.FileName := ChangeFileExt(Cfg.ReadString('Files', 'IOFile', 'koly.rar'), '.rar');
  FixFileName(ExportDialog);
  if ExportDialog.Execute then begin
    URL := Browser.LocationURL;
    OldCurrentProject := CurrentProject;
    Wait(True);
    try
      Cfg.WriteString('Files', 'IOFile', ExportDialog.FileName);
      CloseFile(False);
      try
        Archive := TRARFileSystem.Create(ExportDialog.FileName, fmCreate);
        try
          Archive.CompressLevel := clBest;

          for I := 0 to MRU.Count - 1 do
            if MRU[I].Enabled then
              Check(CopyFile(OSFileSystem, MRU[I].FileName + '.todolist', Archive, ExtractFileName(MRU[I].FileName) + '.todolist'));

        finally
          Archive.Free
        end;
      except
        DeleteFile(ExportDialog.FileName);
        raise
      end;
    finally
      CurrentProject := OldCurrentProject;
      Browser.Navigate(URL);
      Wait(False)
    end
  end
end;

procedure TMainForm.MenuOpenClick(Sender: TObject);
var
  I: Integer;
begin
  if OpenDialog.Execute then
    for I := 0 to OpenDialog.Files.Count - 1 do
      OpenFile(OpenDialog.Files[I], [ofNavigate])
end;

procedure TMainForm.MenuFileImportClick(Sender: TObject);

  function NewerFile(const A: string; const B: string): Boolean;
  var
    AgeA, AgeB: Integer;
  begin
    AgeA := FileAge(A);
    if AgeA = -1 then begin
      // file A doesn't exist so it cannot be newer
      Result := False;
      exit
    end;
    AgeB := FileAge(B);
    if AgeB = -1 then begin
      // file B doesn't exist so it is always older
      Result := True;
      exit
    end;
    Result := AgeA > AgeB
  end;

  function ConfirmOverwrite(const FileName: string): Boolean;
  begin
    case Application.MessageBox('Soubor je novj ne importovan.'#13#10'Pepsat ?', PChar(FileName), mb_yesno or mb_defbutton2 or mb_iconquestion) of
    IDYES: Result := True;
    IDNO: Result := False;
    else
      Result := False
    end
  end;

  procedure ImportFile(const FileName: string);
  var
    Ext: string;
    Archive: TRARFileSystem;
    Search: TSearchRec;
    Found: Integer;
    Mapping: TFileMapping;
    S: string;
    Folder: string;
    R: TRegistry;
  begin
    Ext := ExtractFileExt(FileName);
    if SameText(Ext, '.rar') then begin
      Archive := TRARFileSystem.Create(FileName, fmOpenRead);
      try
        Found := Archive.FindFirst('*.todolist', faAnyFile, Search);
        try
          while Found = 0 do begin
            Mapping := Archive.CreateFileMapping(Search.Name, OSFileSystem);
            try
              ImportFile(Mapping.target.fileName)
            finally
              Mapping.Free
            end;
            Found := Archive.FindNext(Search)
          end;
        finally
          Archive.FindClose(Search);
        end
      finally
        Archive.Free
      end
    end else
    if SameText(Ext, '.todolist') then begin
      S := ProjectFile(ProjectName(ChangeFileExt(ExtractFileName(FileName), '')));
      if S = '' then begin
        // find proper local location
        R := TRegistry.Create;
        try
          R.RootKey := HKEY_CURRENT_USER;
          Check(R.OpenKeyReadOnly('\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders'));
          Folder := R.ReadString('Personal');
          Check(Folder <> '');
          S := CreateFileName(OSFileSystem, Folder, 'koly', True) + ChangeFileExt(ExtractFileName(FileName), '')
        finally
          R.Free
        end;
      end;
      if (not NewerFile(S + '.todolist', FileName)) or ConfirmOverwrite(S + '.todolist') then begin
        ForceDirectories(ExtractFilePath(S));
        Check(CopyFile(FileName, S + '.todolist'));
        OpenFile(S + '.todolist', [ofNavigate])
      end
    end else
      // TODO:
      Assert(False)
  end;

var
  URL: string;
  OldCurrentProject: string;
  I: Integer;
begin
  ImportDialog.FileName := Cfg.ReadString('Files', 'IOFile', 'koly.rar');
  FixFileName(ImportDialog);
  if ImportDialog.Execute then begin
    Wait(True);
    try
      for I := 0 to ImportDialog.Files.Count - 1 do begin
        Cfg.WriteString('Files', 'IOFile', ImportDialog.Files[I]);
        CloseFile(True);
        ImportFile(ImportDialog.Files[I])
      end
    finally
      Wait(False)
    end
  end
end;

procedure TMainForm.SetFullScreen(Value: Boolean);
var
  Tmp: TWindowStyle;
begin
  if FFullScreen = Value then exit;
  FFullScreen := Value;
  if Value then begin
    if not Assigned(FNormalStyle) then begin
      FNormalStyle := TWindowStyle.Create(Self);
      FNormalStyle.Load
    end;
    Menu := nil;
    FNormalStatusBar := StatusBar.Visible;
    StatusBar.Visible := False;
    FNormalWindowState := WindowState;
    FNormalRect := NormalWindowRect(Self);
    WindowState := wsMaximized;
    Tmp := TWindowStyle.Create(Self);
    Tmp.Assign(FNormalStyle);
    Tmp.Style := Tmp.Style and (not (WS_BORDER or WS_CAPTION));
    Tmp.Save;
    Tmp.Apply;
    Tmp.Free
  end else begin
    StatusBar.Visible := FNormalStatusBar;
    Menu := MainMenu;
    FNormalStyle.Save;
    FNormalStyle.Apply;
    WindowState := FNormalWindowState;
    if FNormalWindowState <> wsMaximized then
      with FNormalRect do
        SetBounds(Left, Top, Right - Left, Bottom - Top)
  end
end;

procedure TMainForm.MenuFullScreenClick(Sender: TObject);
begin
  FullScreen := MenuFullScreen.Checked
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F11) and (Shift = []) then begin
    Key := 0;
    MenuFullScreen.Click
  end
end;

function TMainForm.BrowserTranslateAccelerator(const lpMsg: PMsg;
  const pguidCmdGroup: PGUID; const nCmdID: Cardinal): HRESULT;
var
  Handled: Boolean;
  Msg: TMessage;
  KeyMsg: TWMKey absolute Msg;
  ShiftState: TShiftState;
  Key: Word;
begin
  Msg.Msg := lpMsg^.message;
  Msg.WParam := lpMsg^.wParam;
  Msg.LParam := lpMsg^.lParam;
  Msg.Result := 0;

  case lpMsg^.message of
  WM_KEYDOWN:
    begin
      ShiftState := KeyDataToShiftState(KeyMsg.KeyData);
      Key := KeyMsg.CharCode;

      if Assigned(OnKeyDown) then
        OnKeyDown(Browser, Key, ShiftState);
      Handled := Key = 0
    end;

  WM_KEYUP:
    begin
      ShiftState := KeyDataToShiftState(KeyMsg.KeyData);
      Key := KeyMsg.CharCode;

      if Assigned(OnKeyUp) then
        OnKeyUp(Browser, Key, ShiftState);
      Handled := Key = 0
    end;

  else
    Handled := False
  end;
  if Handled then
    Result := S_OK
  else
    Result := S_FALSE
end;

procedure TMainForm.FontSizeChanged(Sender: TObject);
begin
  FontSize := 0;
  Browser.Refresh
end;

function TMainForm.GetFontSize: Integer;
var
  I: Integer;
begin
  if FFontSize = 0 then begin
    for I := 0 to MenuFontSize.Count - 1 do
      if MenuFontSize.Items[I].Checked then begin
        FFontSize := MenuFontSize.Items[I].Tag;
        break
      end
  end;
  Result := FFontSize;
end;

procedure TMainForm.SetFontSize(Value: Integer);
var
  I: Integer;
begin
  FFontSize := 0;
  for I := 0 to MenuFontSize.Count - 1 do
    if MenuFontSize.Items[I].Tag = Value then begin
      MenuFontSize.Items[I].Checked := True;
      break
    end
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if ActiveControl = Browser then
    Browser.SetFocusToDoc
end;

procedure TMainForm.ScheduleAutoSave(Sender: TObject);
begin
  AutoSaveTimer.Enabled := True
end;

procedure TMainForm.AutoSaveTimerTimer(Sender: TObject);
var
  URL: string;
  OldCurrentFile: string;
  Password: string;
begin
  AutoSaveTimer.Enabled := False;

  OldCurrentFile := CurrentFile;
  if OldCurrentFile <> '' then begin
    Wait(True);
    try
      Password := Todo.Password;
      CloseFile(False);
      OpenFile(OldCurrentFile, [ofUsePassword, ofRaiseException], Password)
    finally
      // TODO: tohle by vymazalo aktuln zadvan formul
      // Browser.Refresh;
      Wait(False)
    end
  end
end;

procedure TMainForm.HideSplash(Sender: TObject);
begin
  wSplash.Hide
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  OnShow := nil;
  NotifyWhenIdle(nil, HideSplash)
end;

procedure TMainForm.MenuAboutClick(Sender: TObject);
begin
  // TODO: about.htm TODO...
  Browser.Navigate(Format('http://127.0.0.1:%d/%sabout.htm', [Server.Port, WebRootPath]))
end;

procedure TMainForm.MenuFileCryptClick(Sender: TObject);
var
  Pwd: string;
begin
  if Assigned(Todo) then begin
    Pwd := Todo.Password;
    if InputQuery(CurrentProject, 'Nov heslo', Pwd) then begin
      Todo.Password := Pwd;
      // TODO: nedelej to kdyz je zrovna zobrazeny formular aby se neztratily
      // zrovna zadavane udaje
      Browser.Refresh
    end
  end
end;

end.

